diff a/test/lib/jdk/test/whitebox/WhiteBox.java b/test/lib/jdk/test/whitebox/WhiteBox.java
--- a/test/lib/jdk/test/whitebox/WhiteBox.java
+++ b/test/lib/jdk/test/whitebox/WhiteBox.java
@@ -144,10 +144,24 @@
   private native int encodeConstantPoolIndyIndex0(int index);
   public         int encodeConstantPoolIndyIndex(int index) {
     return encodeConstantPoolIndyIndex0(index);
   }
 
+  private native Object[] getObjectsViaKlassOopMaps0(Object thing);
+  public Object[] getObjectsViaKlassOopMaps(Object thing) {
+    Objects.requireNonNull(thing);
+    return getObjectsViaKlassOopMaps0(thing);
+  }
+
+  private native Object[] getObjectsViaOopIterator0(Object thing);
+  public Object[] getObjectsViaOopIterator(Object thing) {
+    Objects.requireNonNull(thing);
+    return getObjectsViaOopIterator0(thing);
+  }
+
+  public native Object[] getObjectsViaFrameOopIterator(int depth);
+
   private native int getFieldEntriesLength0(Class<?> aClass);
   public         int getFieldEntriesLength(Class<?> aClass) {
     Objects.requireNonNull(aClass);
     return getFieldEntriesLength0(aClass);
   }
diff a/test/lib/org/openjdk/asmtools/JtregDriver.java b/test/lib/org/openjdk/asmtools/JtregDriver.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/JtregDriver.java
@@ -0,0 +1,184 @@
+/*
+ * Copyright (c) 2022, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.asmtools;
+
+import java.lang.reflect.Method;
+import java.lang.reflect.InvocationTargetException;
+import java.util.ArrayList;
+import java.nio.file.Path;
+import java.nio.file.InvalidPathException;
+import java.nio.file.Files;
+import java.io.PrintWriter;
+import java.io.IOException;
+import org.openjdk.asmtools.jdis.uEscWriter;
+
+/**
+ * An entry point to AsmTools for use with the jtreg '@run driver' command.
+ * Unlike 'Main', never invokes 'System.exit' (which crashes jtreg).
+ *
+ * Also adjusts file paths:
+ *
+ * - For jasm and jcoder, source files are expected to appear in ${test.src},
+ *   and output is sent to ${test.classes}
+ *
+ * - For other tools, class files are expected to appear in ${test.classes},
+ *   and output is sent to the scratch working directory
+ *
+ * Example jtreg usage:
+ *
+ * @library /test/lib
+ * @build org.openjdk.asmtools.* org.openjdk.asmtools.jasm.*
+ * @run driver org.openjdk.asmtools.JtregDriver jasm -strict TestFile.jasm
+ */
+public class JtregDriver {
+
+    public static void main(String... args) throws Throwable {
+        // run AltLoaderMain from a class loader that prefers the modified AsmTools classes
+        ClassLoader loader = JtregDriver.class.getClassLoader();
+        Path file = Path.of(loader.getResource("org/openjdk/asmtools/JtregDriver.class").toURI());
+        Path root = file.getParent().getParent().getParent().getParent();
+        ClassLoader altLoader = new AsmToolsClassLoader(root);
+        Class<?> altMain = altLoader.loadClass(AltLoaderMain.class.getName());
+        try {
+            altMain.getMethod("main", String[].class).invoke(null, (Object) args);
+        } catch (InvocationTargetException e) {
+            throw e.getCause();
+        }
+    }
+
+    public static class AltLoaderMain {
+
+        public static void main(String... args) throws IOException {
+            if (args.length == 0) {
+                throw new IllegalArgumentException("Missing asmtools command");
+            }
+            String cmd = args[0];
+            if (!cmd.equals("jasm") && !cmd.equals("jdis") && !cmd.equals("jcoder")
+                    && !cmd.equals("jdec") && !cmd.equals("jcdec")) {
+                throw new IllegalArgumentException("Unrecognized asmtools command: " + cmd);
+            }
+            boolean isAssembler = cmd.equals("jasm") || cmd.equals("jcoder");
+            String srcDir = System.getProperty("test.src", ".");
+            String clsDir = System.getProperty("test.classes", ".");
+            String fileDir = isAssembler ? srcDir : clsDir;
+
+            ArrayList<String> toolArgList = new ArrayList<String>();
+
+            if (isAssembler) {
+                Path destPath = Path.of(clsDir);
+                if (!Files.exists(destPath)) {
+                    // jtreg creates classes dir on demand, might not have happened yet
+                    Files.createDirectories(destPath);
+                }
+                toolArgList.add("-d");
+                toolArgList.add(clsDir);
+            }
+
+            boolean isOptionArg = false; // marks an argument to a previous option
+            for (int i = 1; i < args.length; i++) {
+                String arg = args[i];
+                if (isOptionArg) {
+                    isOptionArg = false; // reset for next
+                } else {
+                    if (arg.equals("-d")) {
+                        isOptionArg = true;
+                    } else if (!arg.startsWith("-") && !arg.startsWith("/")) {
+                        // adjust filename
+                        arg = Path.of(fileDir, arg).toString();
+                    }
+                }
+                toolArgList.add(arg);
+            }
+
+            String[] toolArgs = toolArgList.toArray(new String[0]);
+            boolean success = switch (cmd) {
+                case "jasm" -> {
+                    PrintWriter out = new PrintWriter(System.out);
+                    yield new org.openjdk.asmtools.jasm.Main(out, "jasm").compile(toolArgs);
+                }
+                case "jdis" -> {
+                    PrintWriter out = new PrintWriter(new uEscWriter(System.out));
+                    PrintWriter err = new PrintWriter(System.err);
+                    yield new org.openjdk.asmtools.jdis.Main(out, err, "jdis").disasm(toolArgs);
+                }
+                case "jcoder" -> {
+                    PrintWriter out = new PrintWriter(System.out);
+                    yield new org.openjdk.asmtools.jcoder.Main(out, "jcoder").compile(toolArgs);
+                }
+                case "jdec" -> {
+                    PrintWriter out = new PrintWriter(new uEscWriter(System.out));
+                    PrintWriter err = new PrintWriter(System.err);
+                    yield new org.openjdk.asmtools.jdec.Main(out, err, "jdec").decode(toolArgs);
+                }
+                case "jcdec" -> {
+                    PrintWriter out = new PrintWriter(new uEscWriter(System.out));
+                    yield new org.openjdk.asmtools.jcdec.Main(out, "jcdec").decode(toolArgs);
+                }
+                default -> throw new AssertionError();
+            };
+            if (!success) {
+                throw new RuntimeException("asmtools execution failed");
+            }
+        }
+
+    }
+
+    /**
+     * Class loader for the AsmTools classes. Allows classes colocated with
+     * JtregDriver to have priority over versions of the classes loaded by
+     * jtreg (which includes its own copy of AsmTools).
+     */
+    private static class AsmToolsClassLoader extends ClassLoader {
+        private final Path root;
+        private final String separator;
+
+        public AsmToolsClassLoader(Path root) {
+            super(AsmToolsClassLoader.class.getClassLoader());
+            this.root = root;
+            this.separator = root.getFileSystem().getSeparator();
+        }
+
+        protected Class<?> loadClass(String name, boolean resolve) throws ClassNotFoundException {
+            if (name.startsWith("org.openjdk.asmtools.")) {
+                Class<?> result = findClass(name);
+                if (resolve) resolveClass(result);
+                return result;
+            } else {
+                return super.loadClass(name, resolve);
+            }
+        }
+
+        protected Class<?> findClass(String name) throws ClassNotFoundException {
+            String filename = name.replace(".",separator) + ".class";
+            try {
+                Path classFile = root.resolve(filename);
+                byte[] bytes = Files.readAllBytes(classFile);
+                return defineClass(name, bytes, 0, bytes.length);
+            } catch (InvalidPathException | IOException e) {
+                throw new ClassNotFoundException("can't read class " + filename, e);
+            }
+        }
+
+    }
+
+}
diff a/test/lib/org/openjdk/asmtools/Main.java b/test/lib/org/openjdk/asmtools/Main.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/Main.java
@@ -0,0 +1,125 @@
+/*
+ * Copyright (c) 2009, 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.asmtools;
+
+import org.openjdk.asmtools.util.I18NResourceBundle;
+import org.openjdk.asmtools.util.ProductInfo;
+
+/**
+ * Wrapper class that reads the first command line argument and invokes a corresponding
+ * tool.
+ */
+public class Main {
+
+    public static final I18NResourceBundle i18n
+            = I18NResourceBundle.getBundleForClass(Main.class);
+
+    /**
+     * Parses the first argument and deligates execution to an appropriate tool
+     *
+     * @param args - command line arguments
+     */
+    public static void main(String args[]) {
+        if (args.length == 0) {
+            usage(i18n.getString("main.error.no_arguments"), 1);
+        }
+        String cmd = args[0];
+        if (cmd.equals("-?") || cmd.equals("-h") || cmd.equals("-help")) {
+            usage(null, 0);
+        } else if (cmd.equals("-version")) {
+            printVersion();
+        } else {
+            String[] newArgs = new String[args.length - 1];
+            System.arraycopy(args, 1, newArgs, 0, args.length - 1);
+            if (cmd.equals("jasm")) {
+                jasm(newArgs);
+            } else if (cmd.equals("jdis")) {
+                jdis(newArgs);
+            } else if (cmd.equals("jcoder")) {
+                jcoder(newArgs);
+            } else if (cmd.equals("jdec")) {
+                jdec(newArgs);
+            } else if (cmd.equals("jcdec")) {
+                jcdec(newArgs);
+            } else {
+                usage(i18n.getString("main.error.unknown_tool", cmd), 1);
+            }
+        }
+    }
+
+    /**
+     * Prints usage info and error message, afterwards invokes System.exit()
+     *
+     * @param msg - error message to print, or null if no errors occurred
+     * @param exitCode - exit code to be returned by System.exit()
+     */
+    public static void usage(String msg, int exitCode) {
+        System.err.println(i18n.getString("main.usage", "asmtools.jar"));
+        if (msg != null) {
+            System.err.println(msg);
+        }
+        System.exit(exitCode);
+    }
+
+    /**
+     * Prints the tools version
+     */
+    public static void printVersion() {
+        System.out.println(ProductInfo.FULL_VERSION);
+    }
+
+    /**
+     * Invokes jasm main class with passed arguments
+     */
+    public static void jasm(String[] args) {
+        org.openjdk.asmtools.jasm.Main.main(args);
+    }
+
+    /**
+     * Invokes jcdec main class with passed arguments
+     */
+    public static void jcdec(String[] args) {
+        org.openjdk.asmtools.jcdec.Main.main(args);
+    }
+
+    /**
+     * Invokes jcoder main class with passed arguments
+     */
+    public static void jcoder(String[] args) {
+        org.openjdk.asmtools.jcoder.Main.main(args);
+    }
+
+    /**
+     * Invokes jdec main class with passed arguments
+     */
+    public static void jdec(String[] args) {
+        org.openjdk.asmtools.jdec.Main.main(args);
+    }
+
+    /**
+     * Invokes jdis main class with passed arguments
+     */
+    public static void jdis(String[] args) {
+        org.openjdk.asmtools.jdis.Main.main(args);
+    }
+}
diff a/test/lib/org/openjdk/asmtools/asmutils/HexUtils.java b/test/lib/org/openjdk/asmtools/asmutils/HexUtils.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/asmutils/HexUtils.java
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2014, 2019, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.asmtools.asmutils;
+
+/**
+ *
+ */
+public class HexUtils {
+    /*======================================================== Hex */
+
+    private static final String hexString = "0123456789ABCDEF";
+    private static final char hexTable[] = hexString.toCharArray();
+
+    public static String toHex(long val, int width) {
+        StringBuffer sb = new StringBuffer();
+        for (int i = width - 1; i >= 0; i--) {
+            sb.append(hexTable[((int) (val >> (4 * i))) & 0xF]);
+        }
+        String s = sb.toString();
+        return "0x" + (s.isEmpty() ? "0" : s);
+    }
+
+    public static String toHex(long val) {
+        int width;
+        for (width = 16; width > 0; width--) {
+            if ((val >> (width - 1) * 4) != 0) {
+                break;
+            }
+        }
+        return toHex(val, width);
+    }
+
+    public static String toHex(int val) {
+        int width;
+        for (width = 8; width > 0; width--) {
+            if ((val >> (width - 1) * 4) != 0) {
+                break;
+            }
+        }
+        return toHex(val, width);
+    }
+
+}
diff a/test/lib/org/openjdk/asmtools/asmutils/StringUtils.java b/test/lib/org/openjdk/asmtools/asmutils/StringUtils.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/asmutils/StringUtils.java
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.asmtools.asmutils;
+
+/**
+ * Utility class to share common tools/methods.
+ */
+public class StringUtils {
+    /**
+     * Converts CONSTANT_Utf8_info string to a printable string for jdis/jdes.
+     * @param utf8 UTF8 string taken from within ConstantPool of a class file
+     * @return output string for jcod/jasm
+     */
+    public static String Utf8ToString(String utf8) {
+        StringBuilder sb = new StringBuilder("\"");
+        for (int k = 0; k < utf8.length(); k++) {
+            char c = utf8.charAt(k);
+            switch (c) {
+                case '\t':
+                    sb.append('\\').append('t');
+                    break;
+                case '\n':
+                    sb.append('\\').append('n');
+                    break;
+                case '\r':
+                    sb.append('\\').append('r');
+                    break;
+                case '\b':
+                    sb.append('\\').append('b');
+                    break;
+                case '\f':
+                    sb.append('\\').append('f');
+                    break;
+                case '\"':
+                    sb.append('\\').append('\"');
+                    break;
+                case '\'':
+                    sb.append('\\').append('\'');
+                    break;
+                case '\\':
+                    sb.append('\\').append('\\');
+                    break;
+                default:
+                    sb.append(c);
+            }
+        }
+        return sb.append('\"').toString();
+    }
+}
